/*
 *
 */


/*
 *
 */
package installer.common;


/*
 *
 */
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.util.logging.Logger;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;


/*
 *
 */
public class WelcomePanel extends InstallerPanel
{
    /*
     *
     */
    private JLabel descriptionLabel;
    private VertScrollWidget scrollPane;


    /*
     *
     */
    public WelcomePanel()
    {
        buildGUI();
    }


    /*
     *
     */
    private void buildGUI()
    {
        JLabel titleLabel;


        //
        this.panel.setLayout(new BorderLayout());
        
        //
        titleLabel = new JLabel("<html><h2>Welcome!</h2></html>");
        titleLabel.setHorizontalAlignment(JLabel.CENTER);
        this.panel.add(titleLabel, BorderLayout.NORTH);

        
        this.descriptionLabel =
            new JLabel("<html>\n"
                       + "Welcome to the installer for WFDB Tools for MATLAB. This installer\n"
                       + "will take you through the events needed to copy the proper WFDB files\n"
                       + "onto your computer, and set them up for MATLAB. The sequence of\n"
                       + "installation steps is as follows:\n"
                       + "<br></br><br></br>\n"
                       + "<ul>\n"
                       + "  <li> <b>Choose MATLAB Installations</b><br></br>\n"
                       + "       The installer will search for available MATLAB installations,\n"
                       + "       and then let you specify any others that it could not find.\n"
                       + "  <br></br><br></br>"
                       + "  <li> <b>Perform Main Installation</b><br></br>\n"
                       + "       The WFDB files will be copied into a sub-directory of\n"
                       + "       your home directory, and each installation of MATLAB that\n"
                       + "       was selected in the previous step will be set up to use them.\n"
                       + "       Then, a quick test will be run, for each selected MATLAB\n"
                       + "       installation, to ensure that WFDB Tools were set up properly.\n"
                       + "  <br></br><br></br>"
                       + "  <li> <b>Summary</b><br></br>\n"
                       + "       At the end, a summary of the installation results will be\n"
                       + "       presented.\n"
                       + "</ul>\n"
                       + "<br></br><br></br>\n"
                       + "Windows users: as the installer runs, you may see MATLAB windows briefly appear;\n"
                       + "this is normal.\n"
                       + "<br></br><br></br>\n"

                       + "GNU/Linux users: if you are prompted for your password for superuser\n"
                       + "access, please be aware that sudo will be used, not su. (An option to\n"
                       + "use su instead is forthcoming.) Also, glibc 2.4 or newer is currently\n"
                       + "required (but support for glibc 2.3 is forthcoming.)\n"
                       + "<br></br><br></br>\n"

                       + "Please also note that an installation of MATLAB must have\n"
                       + "Java version 1.4 or higher in order to use WFDB Tools. You can\n"
                       + "check the version yourself by running \"version -java\" (without\n"
                       + "quotes) in MATLAB. (Also note that this Java version does not\n"
                       + "necessarily match the version on your computer, outside of MATLAB.)\n"
                       + "Some older version of MATLAB, for example, come with Java 1.3.x by\n"
                       + "default. Older versions can be upgraded\n"
                       + "(see <a href=\"http://www.mathworks.com/support/solutions/data/1-1812J.html?solution=1-1812J\">http://www.mathworks.com/support/solutions/data/1-1812J.html?solution=1-1812J</a>),\n"
                       + " but this installer\n"
                       + "does not currently attempt to perform such an upgrade for you.\n"
                       + "</html>\n");

        // // DEBUG
        // this.descriptionLabel =
        //     new JLabel("<html><h1>DO NOT USE ME!</h1><br></br>(currently debugging)</html>");

        this.descriptionLabel.setHorizontalAlignment(JLabel.LEFT);
        this.scrollPane = new VertScrollWidget(this.descriptionLabel);

        this.panel.add(this.scrollPane, BorderLayout.CENTER);
    }


    /*
     *
     */
    public void postload(Controller nativeController,
                         InstallerWindow.NavUpdateListener navUpdateListener)
    {
        navUpdateListener.setPreviousButtonEnabled(false);
        navUpdateListener.setNextButtonEnabled(true);
        this.panel.validate();
    }

    
    /*
     *
     */
    public void preload()
    {
    }


    /*
     *
     */
    public boolean unload()
    {
        return true;
    }
}