/*
 * FIXMEFIXME: not implemented yet!
 */


/*
 *
 */
import java.awt.EventQueue;
import java.io.BufferedReader;
import java.io.File;
import java.io.FilenameFilter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Vector;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

import installer.common.Controller;
import installer.common.InstallerGUI;
import installer.common.NoSuperuserPasswordException;
import installer.common.Pointer;
import installer.common.ProcessExecutionException;
import installer.common.ProcessOutputAnalyzer;
import installer.common.ProcessRunner;
import installer.common.ResourceNotFoundException;


/*
 *
 */
class NativeController extends Controller
{
    /*
     *
     */
    static final String nativeI386BinaryListFileName = "native-lib-files-i386.txt";
    static final String nativePPCBinaryListFileName = "native-lib-files-ppc.txt";


    /*
     *
     */
    static final String withttyPPCNameFileName = "withtty-ppc-name.txt";
    static final String withttyI386NameFileName = "withtty-i386-name.txt";


    // /*
    //  *
    //  */
    // private Logger logger;


    /*
     *
     */
    private String suPath;
    private String sudoPath;


    /*
     *
     */
    private String withttyName;
    private File withttyPath;

    
    /*
     *
     */
    private boolean nativeSpecificFilesCopied;


    /*
     *
     */
    public NativeController()
    {
        // this.logger = null;
        this.suPath = null;
        this.sudoPath = null;
        this.withttyName = null;
        this.withttyPath = null;
        this.nativeSpecificFilesCopied = false;
    }


    /*
     * FIXMEFIXME: withtty doesn't work yet, so this uses the same halfway measure as
     *             windows: throws up a dialog asking the user to make the file accessible
     */
    protected void copyFile(final File sourceFile,
                            final File destinationFile)
        throws IOException,
               NoSuperuserPasswordException
    {
        ProcessRunner.Result<?> cpResult;
        String[] commandLine =
            { "cp", sourceFile.getAbsolutePath(), destinationFile.getAbsolutePath() };

        boolean copiedFile;


        // FIXME: this is in lieu of asking for the root password
        while (true)
        {
            try
            {
                cpResult = ProcessRunner.run(null, commandLine);
            }
            catch (ProcessExecutionException ex)
            {
                // FIXME: log this
                // FIXME: should this really always be turned into an IOException?
                throw new IOException(ex.getMessage());
            }
            
            if (cpResult.processReturnResult == 0)   // cp succeeded
            {
                copiedFile = true;
                this.logger.info("Copied " + sourceFile.getAbsolutePath() + " to "
                                 + destinationFile.getAbsolutePath() + " successfully.\n");
                break;
            }
            else   // cp failed
            {
                final Pointer<Boolean> okToTryAgain = new Pointer<Boolean>(true);

                //
                this.logger.info("Tried to copy " + sourceFile.getAbsolutePath() + " to "
                                 + destinationFile.getAbsolutePath() + ", but failed.\n");

                // FIXMEFIXME: it's really a hack to have this here; it should be abstracted
                try
                {
                    EventQueue.invokeAndWait(new Runnable()
                        {
                            public void run()
                            {
                                int result;

                                // FIXME: use frame as first arg.
                                result = 
                                    JOptionPane.showConfirmDialog(null,
                                                                  "The installation needs to copy \n"
                                                                  + sourceFile.getAbsolutePath() + " \n"
                                                                  + "to "
                                                                  + destinationFile.getAbsolutePath()
                                                                  + "\n"
                                                                  + "but is not able to do so; this is "
                                                                  + "most likely because of a lack of "
                                                                  + "proper permission.\n"
                                                                  + "Please make the file accessible "
                                                                  + "(non-read-only, and writeable by "
                                                                  + "your user account) and then click "
                                                                  + "\"OK\" to try again.\n"
                                                                  + "If you choose to cancel, "
                                                                  + "installation for this version of "
                                                                  + "MATLAB will not be completed.",
                                                                  "Error Copying Files",
                                                                  JOptionPane.OK_CANCEL_OPTION);
                                okToTryAgain.object = (result == JOptionPane.OK_OPTION);
                            }
                        });

                    if (okToTryAgain.object)
                    {
                        continue;
                    }
                    else
                    {
                        copiedFile = false;
                        break;
                    }
                }
                catch (InterruptedException ex)
                {
                    copiedFile = false;
                    break;
                }
                catch (InvocationTargetException ex)
                {
                    copiedFile = false;
                    break;
                }
            }
        }

        if (!copiedFile)
        {
            throw new IOException("Unable to copy "
                                  + sourceFile.getAbsolutePath()
                                  + " to " + destinationFile.getAbsolutePath());
        }

        // //
        // try
        // {
        //     cpResult = ProcessRunner.run(null, commandLine);
        // }
        // catch (ProcessExecutionException ex)
        // {
        //     // FIXME: log this
        //     // FIXME: should this really always be turned into an IOException?
        //     throw new IOException(ex.getMessage());
        // }

        // //
        // if (cpResult.processReturnResult != 0)
        // {
        //     // FIXME: we're assuming the failure was because we aren't superuser;
        //     //        this is not exactly robust, it's just the most likely outcome
        //     ensureSuperuserPasswordAvailable();


        //     //
        //     try
        //     {
        //         cpResult = runAsRoot(null, commandLine);
        //     }
        //     catch (ProcessExecutionException ex)
        //     {
        //         // FIXME: log this
        //         // FIXME: should this really always be turned into an IOException?
        //         throw new IOException(ex.getMessage());
        //     }
            
        //     if (cpResult.processReturnResult != 0)
        //     {
        //         // FIXME: this should not really be an IOException...
        //         throw new IOException("Unable to copy "
        //                               + sourceFile.getAbsolutePath()
        //                               + " to " + destinationFile.getAbsolutePath()
        //                               + ", even as superuser (command return value was "
        //                               + cpResult.processReturnResult + ")");
        //     }
        // }
    }


    /*
     * withtty is a helper program that runs a command in a pseudo-tty (necessary for su
     * and sometimes sudo)
     *
     * arch should be an available arch that can run withtty
     * (should be either "ppc" or "i386" at the moment)
     */
    protected void copyNativeSpecificFilesFromPackageToHost(String arch)
        throws IOException,
               ProcessExecutionException,
               ResourceNotFoundException
    {
        Set<String> withttyNames;

        
        // we never need to do this twice!
        if (this.nativeSpecificFilesCopied)
        {
            return;
        }

        //
        if (arch.equals("i386"))
        {
            withttyNames = getResourceNamesFromTextFileResource(withttyI386NameFileName);
        }
        else if (arch.equals("ppc"))
        {
            withttyNames = getResourceNamesFromTextFileResource(withttyPPCNameFileName);
        }
        else
        {
            // this should never happen
            // FIXME: perhaps slightly improper use of IOException
            throw new IOException("unavailable arch. requested for withtty: " + arch);
        }
        assert(withttyNames.size() == 1);

        // FIXME: need to perform a cleanup on withtty
        this.withttyName = withttyNames.iterator().next();
        this.withttyPath = new File(getActiveConfigDirectory(),
                                    localizeRelativePath(this.withttyName));
        copyResourceToLocalFile(this.withttyName, this.withttyPath);
        makeFileExecutable(this.withttyPath);

        //
        this.nativeSpecificFilesCopied = true;
    }


    /*
     * scan /Applications/ for directories named as "MATLAB*"
     *
     * return an empty Set if no installations of MATLAB are found
     *
     * FIXME: this seems like a somewhat bad way to look for MATLAB
     *        paths, but i don't know any better way yet
     */
    private Set<File> findMatlabPaths()
    {
        File applicationsDir;
        String[] matlabDirNames;
        Set<File> matlabDirs;


        //
        applicationsDir = new File("/Applications");
        matlabDirNames = applicationsDir.list(new FilenameFilter() {
                public boolean accept(File dir, String name)
                {
                    return name.startsWith("MATLAB");
                }
            });

        //
        matlabDirs = new HashSet<File>();
        for (String dirName : matlabDirNames)
        {
            matlabDirs.add(new File(applicationsDir, dirName));
        }

        //
        return matlabDirs;
    }


    /*
     *
     */
    public Map<File, InstallerGUI.MatlabInstallation> findMatlabPathsAndVersions()
    {
        Set<File> matlabPaths;
        Map<File, InstallerGUI.MatlabInstallation> matlabPathsToVersions;


        //
        this.logger.info("Looking for MATLAB paths...\n");
        matlabPaths = findMatlabPaths();
        matlabPathsToVersions = new HashMap<File, InstallerGUI.MatlabInstallation>();

        //
        for (File matlabPath : matlabPaths)
        {
            InstallerGUI.MatlabInstallation matlabInst =
                verifyMatlabPathAndGetVersion(matlabPath);

            if (matlabInst == null)
            {
                this.logger.severe("Unable to verify MATLAB installation in "
                                   + matlabPath.getAbsolutePath() + "\n");
                continue;
            }
            else
            {
                matlabPathsToVersions.put(matlabPath, matlabInst);
            }
        }

        //
        return matlabPathsToVersions;
    }


    /*
     *
     */
    protected boolean
        gatherPlatformDependentConfigurationInformation(List<String> errors) // out
    {
        boolean fullySucceeded;


        //
        this.suPath = null;
        this.sudoPath = null;
        fullySucceeded = true;

        //
        try
        {
            this.suPath =
                ProcessRunner.run(new ProcessOutputAnalyzer.LastLine(), "which", "su").outputResult;
        }
        catch (ProcessExecutionException ex)
        {
            fullySucceeded = false;
            errors.add("Unable to get location of su: " + ex.getMessage());
        }

        try
        {
            this.sudoPath =
                ProcessRunner.run(new ProcessOutputAnalyzer.LastLine(),
                                  "which", "sudo").outputResult;
        }
        catch (ProcessExecutionException ex)
        {
            fullySucceeded = false;
            errors.add("Unable to get location of sudo: " + ex.getMessage());
        }

        //
        return fullySucceeded;
    }


    /*
     *
     */
    protected File getMatlabUserpathGuess()
    {
        return new File(getUserHomeDirectory(), "matlab");
    }


    /*
     *
     */
    protected Set<String> getNativeBinaryFileNames(String arch)
        throws IOException
    {
        if (arch.equals("ppc"))
        {
            return getResourceNamesFromTextFileResource(nativePPCBinaryListFileName);
        }
        else if (arch.equals("i386"))
        {
            return getResourceNamesFromTextFileResource(nativeI386BinaryListFileName);
        }
        else
        {
            // this should never happen
            throw new IOException("Unsupported arch. libs. requested (this is a bug!)");
        }
    }


    /*
     * FIXME FILLME: currently unimplemented, because only critical on windows!
     */
    protected boolean isFileReadOnly(File file)
        throws IOException
    {
        return false;
    }


    // /*
    //  * FIXME: untested
    //  */
    // private void makeFileExecutable(File exeFile)
    //     throws ProcessExecutionException
    // {
    //     ProcessRunner.Result<?> chmodResult;
    //     String[] commandLine;


    //     //
    //     commandLine = new String[] { "chmod", "+x", exeFile.getAbsolutePath() };
    //     chmodResult = ProcessRunner.run(null, commandLine);
    //     if (chmodResult.processReturnResult != 0)
    //     {
    //         throw new ProcessExecutionException(commandLine, "chmod didn't return 0");
    //     }
    // }


    /*
     * arch should be non-null
     */
    protected boolean isSupportedArch(String arch)
    {
        return arch.equals("ppc") || arch.equals("i386");
    }


    /*
     * version should be non-null
     *
     * FIXME FILLME
     */
    protected boolean isSupportedMatlabVersion(String version)
    {
        return true;
    }


    /*
     *
     */
    protected void launchMatlabWithCommand(File matlabPath,
                                           String matlabCommand,
                                           File workingDirectory)
        throws IOException
    {
        // FIXME: use working dir.
        MacOSXMatlabRunner.get().launch(matlabPath, matlabCommand, workingDirectory);
    }


    /*
     *
     */
    private void makeFileExecutable(File exeFile)
        throws ProcessExecutionException
    {
        ProcessRunner.Result<?> chmodResult;
        String[] commandLine;


        //
        commandLine = new String[] { "chmod", "+x", exeFile.getAbsolutePath() };
        chmodResult = ProcessRunner.run(null, commandLine);
        if (chmodResult.processReturnResult != 0)
        {
            throw new ProcessExecutionException(commandLine, "chmod didn't return 0");
        }
    }


    /*
     * originalCommandLine should be non-null, should contain at least
     * one element, and each of its elements should be non-null
     *
     * FIXME: should be able to use sudo or su
     */
    private <OutputType> ProcessRunner.Result<OutputType>
        runAsRoot(ProcessOutputAnalyzer<OutputType> outputAnalyzer,
                  String... originalCommandLine)
        throws ProcessExecutionException
    {
        String[] sudoCommandLine = null; // FIXME: rename to commandLine
        int i;
        
        
        // FIXME: this is a bit of a hack
        if (!this.withttyPath.exists())
        {
            withttyPath = new File(getActiveConfigDirectory(), this.withttyName);
        }
        
        //
        switch (getSuperuserPassword().authenticationMethod)
        {
        case SU:
            // build the root command line -- not as nasty as it looks;
            // e.g., {"cp", "X", "Y"} becomes
            //       {"withtty", "su", "DUMMY_PROMPT", "/bin/sh", "-c",
            //        "su -s /bin/sh -c \"$1 $2 $3\"",
            //        "su", "cp", "X", "Y"}
            sudoCommandLine = new String[7 + originalCommandLine.length];
            sudoCommandLine[0] = this.withttyPath.getAbsolutePath();
            sudoCommandLine[1] = "su";
            sudoCommandLine[2] = "DUMMY_PROMPT";
            sudoCommandLine[3] = "/bin/sh";
            sudoCommandLine[4] = "-c";
            sudoCommandLine[5] = this.suPath + " -s /bin/sh -c \"";
            for (i = 1; i <= originalCommandLine.length; ++i)
            {
                sudoCommandLine[5] += " $" + i;
            }
            sudoCommandLine[5] += "\"";
            sudoCommandLine[6] = "su";
            for (i = 0; i < originalCommandLine.length; ++i)
            {
                sudoCommandLine[7 + i] = originalCommandLine[i];
            }
            break;
            
        case SUDO:
            // build the root command line -- not as nasty as it looks;
            // e.g., {"cp", "X", "Y"} becomes
            //       {"withtty", "sudo", "WSM_INSTALL_SUDO_PROMPT", "/bin/sh", "-c",
            //        "sudo -K; sudo -p WSM_INSTALL_SUDO_PROMPT $1 $2 $3",
            //        "sudo", "cp", "X", "Y"}
            sudoCommandLine = new String[7 + originalCommandLine.length];
            sudoCommandLine[0] = this.withttyPath.getAbsolutePath();
            sudoCommandLine[1] = "sudo";
            sudoCommandLine[2] = "WSM_INSTALL_SUDO_PROMPT";
            sudoCommandLine[3] = "/bin/sh";
            sudoCommandLine[4] = "-c";
            sudoCommandLine[5] = this.sudoPath + " -K; "
                + this.sudoPath + " -p WSM_INSTALL_SUDO_PROMPT";
            for (i = 1; i <= originalCommandLine.length; ++i)
            {
                sudoCommandLine[5] += " $" + i;
            }
            sudoCommandLine[6] = "sudo";
            for (i = 0; i < originalCommandLine.length; ++i)
            {
                sudoCommandLine[7 + i] = originalCommandLine[i];
            }
            break;
        }
        
        //
        return ProcessRunner.run((getSuperuserPassword().passwordText+"\n").toCharArray(),
                                 outputAnalyzer, sudoCommandLine);
    }


    /*
     *
     */
    public <ResultType> ResultType
        runMatlabCommand(File matlabPath,
                         String matlabCommand,
                         File logFile,
                         ProcessOutputAnalyzer<ResultType> outputAnalyzer)
        throws IOException,
               ProcessExecutionException
    {
        return MacOSXMatlabRunner.get().run(matlabPath, matlabCommand, logFile, outputAnalyzer);
    }


    /*
     * FIXME FILLME: currently unimplemented because only critical on windows
     */
    protected void setFileReadOnly(File file,
                                   boolean readOnly)
        throws IOException
    {
    }


    // /*
    //  * FIXME: this is a bit brittle...
    //  */
    // public void setLogger(Logger logger)
    // {
    //     this.logger = logger;
    // }


    // /*
    //  *
    //  */
    // public InstallerGUI.MatlabInstallation verifyMatlabPathAndGetVersion(File matlabPath)
    //     throws IOException
    // {
    //     final String matlabVersionCommand = "nl=['\\','n'];fprintf(1,['%s',nl],version);exit;";
    //     final String matlabArchCommand =
    //         "nl=['\\','n'];fprintf(1,['%s',nl],char(java.lang.System.getProperty('os.arch')));exit;";

        
    //     //
    //     try
    //     {
    //         String arch;
    //         String version;

    //         arch = runMatlabCommand(matlabPath, matlabArchCommand, null);
    //         if (arch == null
    //             || (!arch.equals("ppc")))
    //         {
    //             logger.severe("Unable to use MATLAB in " + matlabPath.getAbsolutePath() + " -- "
    //                           + "the JVM's architecture is "
    //                           + ((arch == null) ? "unknown (Java property os.arch missing!)"
    //                              : arch) + ", "
    //                           + "but currently only ppc is supported!\n");
    //             return null;
    //         }

    //         version = runMatlabCommand(matlabPath, matlabVersionCommand, null);
    //         if (version == null)
    //         {
    //             logger.severe("Unable to get version from MATLAB in "
    //                           + matlabPath.getAbsolutePath() + "\n");
    //             return null;
    //         }

    //         return new InstallerGUI.MatlabInstallation(version, arch);
    //     }
    //     catch (IOException ex)
    //     {
    //         this.logger.warning("Unable to verify MATLAB installation in " + matlabPath + ": "
    //                             + ex.getMessage() + "\n");
    //         return null;            
    //     }
    //     catch (ProcessExecutionException ex)
    //     {
    //         this.logger.warning("Unable to verify MATLAB installation in " + matlabPath + ": "
    //                             + ex.getMessage() + "\n");
    //         return null;
    //     }
    // }


    /*
     * return true if the superuser password is correct; false if not
     * FIXMEFIXME: unimplemented!
     */
    protected boolean verifySuperuserPassword(Password superuserPassword)
    {
        // FIXME FILLME
        return false;
    }
}

